
#pragma once

#include "Instance.h"
#include "Ticket.h"

class CCalcResult : public CMessage,  public CTicket
{
public:
	int Value;
public:
	CCalcResult(int v)
		: Value( v )
	{
	}
};

class CCalcRequest : public CMessage
{
public:
	int A;
	int B;
	CMessageQueue m_senderQueue;
public:
	CCalcRequest(int a, int b, CMessageQueue &queue)
		: A( a )
		, B( b )
		, m_senderQueue( queue )
	{
	}
};

class CAddCalculator : public CThread, public CThreadMonitor<CThread>, CMessageQueue
{
public:
	CAddCalculator()
		: CThread( true )
	{
	}

	~CAddCalculator()
	{
		puts( "CAddCalculator - Destroy");
	}

	void Run()
	{
		while (true) {
			if ( !Items.empty() ) {
#if 0
				// 񓯊Ή߂ǂł
				// ĂƂĂȂ@̂
				CCalcRequest *req = dynamic_cast<CCalcRequest*>(Items.front());
				Items.pop();
				if ( req != NULL ) {
					CCalcResult *res = new CCalcResult( req->A + req->B );
					req->m_senderQueue.Items.push( res );
					delete req;
				}
#endif
			} else {
				puts( "CAddCalculator::Run() - Items empty" );
			}
			printf( "CAddCalculator::Run() - Thread Check: %s\n", IsAllActive() ? "ok" : "bad" );
			if ( !IsAllActive() ) {
				break;
			}
			Sleep( 3000 );
		}
	}
};
